//+------------------------------------------------------------------+
//|                                                   volume_PRO.mq5 |
//|               date expires 2011.08.01, MetaQuotes Software Corp. |
//|                              http://www.mql4.com/ru/users/costy_ |
//+------------------------------------------------------------------+
#property copyright "date expires 2013.10.20\nhttp://www.mql4.com/ru/users/costy_\n  .."
#property link      "http://www.mql4.com/ru/users/costy_"
#property version   "1.00"
//#property script_show_inputs
#include <Mylib\objects.mqh>
#include <Mylib\copy_series.mqh>
#include <MovingAverages.mqh>
Ccopyseries my_copy;
Ccopyseries my_copyTime;
#define MAX_int 2147483647
#define MIN_int -2147483648
#define dir "volume_PRO\\"
#define i_persent 0
#define i_kernel  1
#define i_method  2
//---
int zagl=0,tick=0;
double high[],low[],tmp[];
long volume[];
datetime time[];
//---

input double start=0.0067;
input double end=3;

Ccreate_object object;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
// if(!FileIsExist(dir+Symbol()+".dat"))
   while_bez_MARKER();
//---
   double save[][3];
   double buf_pr[];
   int digit=(Digits()==3 || Digits()==5) ? 10 : 1;
   for(double kernel=0;kernel<=100*Point()*digit;kernel+=Point()*digit)
      for(int methode=6;methode<=7;methode++)
        {
         if(IsStopped())return;
         kernel=NormalizeDouble(kernel,Digits());
         double kern=kernel;
         int method=methode;
         //---
         ArrayFree(buf_pr);ArraySetAsSeries(buf_pr,true);
         while(true)
           {
            if(IsStopped())return;
            if(method==7)
              {
               ArrayResize(buf_pr,ArraySize(buf_pr)+1);
               buf_pr[0]=kern+21*Point()*digit;
               for(int j=0;j<method-1;j++)
                 {
                  ArrayResize(buf_pr,ArraySize(buf_pr)+1);
                  buf_pr[0]=buf_pr[1]+20*Point()*digit;
                 }
               kern=buf_pr[0];
               method=6;
              }
            if(method==6)
              {
               ArrayResize(buf_pr,ArraySize(buf_pr)+1);
               buf_pr[0]=kern+21*Point()*digit;
               for(int j=0;j<method-1;j++)
                 {
                  ArrayResize(buf_pr,ArraySize(buf_pr)+1);
                  buf_pr[0]=buf_pr[1]+20*Point()*digit;
                 }
               kern=buf_pr[0];
               method=7;
              }
            if(kern>ArraySize(tmp)*_Point)break;
           }
         //+------------------------------------------------------------------+
         //|                                                                    |
         //+------------------------------------------------------------------+
         //---
         int kol_vo=0,a_sootvetstvie=0;
         for(int i=0;i<ArraySize(buf_pr);i++)
           {
            if(IsStopped())return;
            int poz_vol=(int)(buf_pr[i]/Point())/*/digit*/;
            if(poz_vol>=ArraySize(tmp)-1 || poz_vol<=0)continue;
            double vol=tmp[poz_vol];
            if(vol==0.0)continue;
            //---
            kol_vo++;
            if(vol>tmp[poz_vol+1] && vol>tmp[poz_vol-1])
              {
               a_sootvetstvie++;
               Print(" vol "+vol+" do "+tmp[poz_vol+1]+" posle "+tmp[poz_vol-1]+" kernel "+kernel+" method "+method);
              }
           }
         double persents=(a_sootvetstvie*100)/kol_vo;
         //---
         //+------------------------------------------------------------------+
         //|                 =                                                   |
         //+------------------------------------------------------------------+
         int size_s=ArrayRange(save,0);
         int ind_s=size_s-1<0?0:size_s-1;
         if(size_s<1 || save[ind_s][i_persent]<=persents)
           {
            ArrayResize(save,ArrayRange(save,0)+1);
            size_s=ArrayRange(save,0);
            ind_s=size_s-1<0?0:size_s-1;
            save[ind_s][i_persent]=persents;
            save[ind_s][i_kernel]=kernel;
            save[ind_s][i_method]=methode;
           }
         //Print("persents  "+persents+"%  kernel "+kernel+" methode "+methode);
         //Sleep(400);
        }
//+------------------------------------------------------------------+
//|            max vol                                                      |
//+------------------------------------------------------------------+
   double max_vol=0;
   for(int i=0;i<ArrayRange(save,0);i++)
      if(max_vol<save[i][i_persent])
         max_vol=save[i][i_persent];
//---
   for(int i=0;i<ArrayRange(save,0);i++)
      if(max_vol==save[i][i_persent])
        {
         Print("max_persent  "+save[i][i_persent]+"%  "+save[i][i_kernel]+"  "+save[i][i_method]);
        }
//+------------------------------------------------------------------+
//|                                                                   |
//+------------------------------------------------------------------+
   for(int p=0;p<ArrayRange(save,0);p++)
     {
      if(max_vol!=save[p][i_persent])continue;
      Alert("max_vol "+max_vol);
      double kern=save[p][i_kernel];
      int method=(int)save[p][i_method];
      //---
      ArrayFree(buf_pr);ArraySetAsSeries(buf_pr,true);
      while(true)
        {
         if(IsStopped())return;
         if(method==7)
           {
            ArrayResize(buf_pr,ArraySize(buf_pr)+1);
            buf_pr[0]=kern+21*Point()*digit;
            for(int j=0;j<method-1;j++)
              {
               ArrayResize(buf_pr,ArraySize(buf_pr)+1);
               buf_pr[0]=buf_pr[1]+20*Point()*digit;
              }
            kern=buf_pr[0];
            method=6;
           }
         if(method==6)
           {
            ArrayResize(buf_pr,ArraySize(buf_pr)+1);
            buf_pr[0]=kern+21*Point()*digit;
            for(int j=0;j<method-1;j++)
              {
               ArrayResize(buf_pr,ArraySize(buf_pr)+1);
               buf_pr[0]=buf_pr[1]+20*Point()*digit;
              }
            kern=buf_pr[0];
            method=7;
           }
         if(kern>ArraySize(tmp)*_Point)break;
        }
      //---
      for(int i=0;i<ArraySize(buf_pr);i++)
         object.HLINE(0,"scripts_"+(string)(buf_pr[i]+p),0,buf_pr[i],clrRed,2);
     }
   ChartRedraw();
  }
//}
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int while_bez_MARKER()
  {
   int i,max_pr,min_pr;
   while(!IsStopped())
     {
      Sleep(200);
      ChartRedraw();
      //---
      if(!my_copy.initSymbolPeriod(Symbol(),PERIOD_M1))continue;
      if(!my_copyTime.initSymbolPeriod(Symbol(),PERIOD_CURRENT))continue;
      MqlRates m[];
      if(!my_copy.rates(0,0,m))continue;
      //---
      int size_m=ArraySize(m);
      //---
      max_pr=MIN_int;min_pr=MAX_int;
      size_m=ArraySize(m);
      for(i=0;i<size_m;i++)
        {
         max_pr=max_pr<m[i].high/Point() ? (int)(m[i].high/Point()) : max_pr;
         min_pr=min_pr>m[i].low/Point()  ? (int)(m[i].low/Point())  : min_pr;
        }
      //---
      //  
      ArrayResize(tmp,max_pr+1);
      ArrayInitialize(tmp,0.0);
      for(i=size_m-1;i>=0;i--)
         for(int j=(int)(m[i].low/Point());j<=(int)(m[i].high/Point());j++)
            tmp[j]+=(double)m[i].tick_volume;
      //---
/*  int hendl=FileOpen(dir+Symbol()+".dat",FILE_WRITE|FILE_BIN);
      FileWriteArray(hendl,tmp);
      FileClose(hendl);
      ArrayFree(tmp);*/
      return(1);
     }
   return(1);
  }
//+------------------------------------------------------------------+
